#
# enemy class
# enemy.py
#

import pygame
from pygame.locals import *
import player
import shot
import vector

AI_DUMB = 0
AI_DUMB_STRONGER = 1
SIMPLE_SHOT_DELAY = 0.1

class enemy(player.player):
	def __init__(self,world,drop_info):
		player.player.__init__(self,world)
		self._drop_info = drop_info
		self._eid = drop_info[0]
		self._type = drop_info[1]
		self._simple_delay = SIMPLE_SHOT_DELAY
		# replace sprite by type
		if self._type == AI_DUMB:
			self._sprite = pygame.image.load("enemy1.png").convert_alpha()
		if self._type == AI_DUMB_STRONGER:
			self._sprite = pygame.image.load("enemy2.png").convert_alpha()
			self._life = 250.0
			self._maxlife = 250.0
		self._rotated_sprite = self._sprite
		self._sprite_dict = self._generate_sprites()
	
	def process(self,time_passed):
		self.ai_process(time_passed)
		player.player.process(self,time_passed)
	
	def ai_process(self,time_passed):
		self._simple_delay -= time_passed / 1000.0
		if self._type == AI_DUMB:
			# stays in place and shoots player when it has line of sight
			if self._simple_delay <= 0:
				if self._world._level.has_line_of_sight(
					self._world._objs[self._world._player_id]._pos,
					self._pos,
					shot.SHOT_DICT[shot.SIMPLE][2]):
					player.player.shoot(self,shot.SIMPLE,self._world._objs[self._world._player_id]._pos - self._pos)
					self._simple_delay = SIMPLE_SHOT_DELAY
			return
		if self._type == AI_DUMB_STRONGER:
			# stays in place shoots player and moves back from player
			if self._simple_delay <= 0:
				if self._world._level.has_line_of_sight(
					self._world._objs[self._world._player_id]._pos,
					self._pos,
					shot.SHOT_DICT[shot.SIMPLE][2]):
					player.player.shoot(self,shot.SIMPLE,self._world._objs[self._world._player_id]._pos - self._pos)
					self._simple_delay = SIMPLE_SHOT_DELAY
					self._heading = self._pos - self._world._objs[self._world._player_id]._pos
					self._heading._x = round(self._heading._x * (1 / abs(self._heading._x)))
					self._heading._y = round(self._heading._y * (1 / abs(self._heading._y)))
					self._heading.normalize()
				else:
					self._heading = vector.twin(0,0)
			return
			