#
# highscore class
# highscore.py
#

import pygame
from pygame import *

class highscore():
	def __init__(self,screen,res):
		self._screen = screen
		self._res = res
		self._file = "highscore_data"
		tmp = __import__(self._file)
		self._score = tmp.table
		del tmp
		self._title_font = pygame.font.SysFont("courbd", 64);
		self._score_font = pygame.font.SysFont("courbd", 28);
		self._titles = [
			self._title_font.render("Highscore Table",True,(255,255,255)),
			self._title_font.render("Enter your Name:",True,(255,255,255))
			]
		self._entering_index = -1
	
	def new_highscore(self,score):
		idx = -1
		for i in range(len(self._score)):
			if self._score[i][1] < score:
				idx = i
				break
		# sanity
		if idx == -1:
			return
		# move the scores down
		self._score = self._score[:idx] + [["",score]] + self._score[idx:-1]
		self._entering_index = idx
		
	def is_highscore(self,score):
		if score > self._score[-1][1]:
			return True
		return False
		
	def draw_show(self,title=0):
		yoff = 30
		self._screen.blit(self._titles[title],((self._res[0] - self._titles[0].get_width()) / 2,yoff))
		yoff += 70
		for score in self._score:
			name_img = self._score_font.render(score[0],True,(255,255,255))
			score_img = self._score_font.render("%d" % score[1],True,(255,255,255))
			self._screen.blit(name_img,(60,yoff))
			self._screen.blit(score_img,(self._res[0] - score_img.get_width() - 70,yoff))
			yoff += 30
	
	def draw_enter(self):
		self.draw_show(1)
	
	def process_key_event(self,event):
		if self._entering_index != -1:
			if event.key == K_RETURN:
				self._entering_index = -1
				self.save_highscore()
				return True
			if event.key == K_BACKSPACE:
				self._score[self._entering_index][0] = self._score[self._entering_index][0][:-1]
				return False
			if event.unicode:
				try:
					txt = event.unicode.encode("latin")
				except:
					return False
				self._score[self._entering_index][0] += txt
			return False
		return False
	
	def save_highscore(self):
		fh = file(self._file + ".py","wt")
		fh.write("table = %s" % repr(self._score))
		fh.close()
		