#
# hud displaying module
# hud.py
#

import pygame
from pygame.locals import *
import shot

class hud():
	def __init__(self,world,player_id):
		self._world = world
		self._pid = player_id
		# generate initial surface
		self._img = pygame.Surface((self._world._res[0],self._world._res[1]),0,32).convert_alpha()
		self._img.fill((0,0,0,0))
		# draw icons
		smaller_player = pygame.transform.scale(self._world._objs[self._pid]._sprite,(16,16))
		self._img.blit(smaller_player,(15,self._world._res[1] - 44))
		self._img.blit(shot.SHOT_DICT[shot.SIMPLE][4],(20,self._world._res[1] - 18))
		self._img.blit(shot.SHOT_DICT[shot.POWER][4],(self._world._res[0] - 175,self._world._res[1] - 40))
		self._img.blit(shot.SHOT_DICT[shot.GRENADE][4],(self._world._res[0] - 175,self._world._res[1] - 18))
		
		
		self._font = pygame.font.SysFont("courbd", 32);
		self._render_score(self._world._score)
		self._render_time(self._world._level._time_left)
		self._last_values = [-1,-1,-1,-1]
		self._img_bar = [
			pygame.Surface((150,10),0,32).convert(),
			pygame.Surface((150,10),0,32).convert(),
			pygame.Surface((150,10),0,32).convert(),
			pygame.Surface((150,10),0,32).convert()
		]
	
	def _render_score(self,score):
		self._last_score = score
		self._img_score = self._font.render("%d" % self._last_score,True,(255,255,255)).convert_alpha()
	
	def _render_time(self,time):
		self._last_time = int(time)
		self._img_time = self._font.render("%d" % self._last_time,True,(255,255,255)).convert_alpha()
	
	def _render_bar(self,barinfo,i):
		sw = self._img_bar[i].get_width()
		sh = self._img_bar[i].get_height()
		self._last_values[i] = barinfo[1]
		self._img_bar[i].fill((0,0,0))
		pygame.draw.rect(self._img_bar[i],(255,255,255),(0,0,sw - 1,sh - 1),1)
		self._img_bar[i].fill(barinfo[2],(1,1,(sw - 2) * barinfo[1] / 100.0,sh - 2))
	
	def draw(self):
		# frame
		self._world._screen.blit(self._img,(0,0))
		# score
		if self._world._score != self._last_score:
			self._render_score(self._world._score)
		self._world._screen.blit(self._img_score,
		(((self._world._res[0] - self._img_score.get_width()) / 2),
		(self._world._res[1] - self._img_score.get_height() - 10)))
		# time
		if int(self._world._level._time_left) != self._last_time:
			self._render_time(self._world._level._time_left)
		self._world._screen.blit(self._img_time,
		(((self._world._res[0] - self._img_time.get_width()) / 2),
		10))
		# status bars
		status_bars = [
		# [position, percent full, color]
		[(40,self._world._res[1] - 40),int(self._world._objs[self._pid]._life),(255,128,128)],
		[(40,self._world._res[1] - 20),
			int(100.0 * self._world._objs[self._pid]._weapons[shot.SIMPLE]["charge"] / self._world._objs[self._pid]._weapons[shot.SIMPLE]["maxcharge"]),
			(128,190,255)],
		[(self._world._res[0] - self._img_bar[3].get_width() - 10,self._world._res[1] - 40),
			int(100.0 * self._world._objs[self._pid]._weapons[shot.POWER]["charge"] / self._world._objs[self._pid]._weapons[shot.POWER]["maxcharge"]),
			(128,128,255)],
		[(self._world._res[0] - self._img_bar[3].get_width() - 10,self._world._res[1] - 20),
			int(100.0 * self._world._objs[self._pid]._weapons[shot.GRENADE]["charge"] / self._world._objs[self._pid]._weapons[shot.GRENADE]["maxcharge"]),
			(190,128,255)],			
		]
		for i in range(len(status_bars)):
			if self._last_values[i] != status_bars[i][2]:
				self._render_bar(status_bars[i],i)
			self._world._screen.blit(self._img_bar[i],status_bars[i][0])
		