#
# vector class
# vector.py
#

import math

class twin():
	def __init__(self,x,y = None):
		if y == None:
			y = x[1]
			x = x[0]
		self._x = x
		self._y = y
	
	def __eq__(self,val):
		if self._x == val._x and self._y == val._y:
			return True
		return False
		
	def __str__(self):
		return "<%f,%f>" % (self._x,self._y)
	
	def set(self,val):
		self._x = val._x
		self._y = val._y
	
	def get(self):
		return (self._x,self._y)
	
	def __add__(self,val):
		return twin(self._x + val._x,self._y + val._y)
	
	def __sub__(self,val):
		return twin(self._x - val._x,self._y - val._y)
		
	def len(self):
		return math.sqrt(self._x ** 2 + self._y ** 2)
		
	def normalize(self):
		vlen = self.len()
		if vlen == 0:
			return
		self._x = self._x / vlen
		self._y = self._y / vlen
	
	def __mul__(self,val):
		return twin(self._x * val,self._y * val)
	
	def __div__(self,val):
		return twin(self._x / val,self._y / val)
